%% T-61.2010 Datasta tietoon / T#2 / 2
% Jukka Parviainen, 14.11.2006
%
% Ladataan datamatriisi, tarkastellaan sit ja
% tehdn pkomponenttianalyysi (PCA, Principal Component Analysis).

clc;        % tyhjenn nytt
clear       % poista muistista muuttujat
close all   % sulje kaikki ikkunat

%% Lataa tiedosto
load X.txt -ascii

%% Tarkista, mit muuttujia tuli Matlabiin
whos

%% Mik on muuttujan X dimensio?
% Matlabissa ilmoitetaan ensin rivien lkm, 
% sitten sarakkeiden lkm (ja sen jlkeen mahdollisten muiden
% dimensioiden koko).
%
% Tss oletetaan, ett datan dimensio kasvaa alaspin ja
% datapisteiden lukumr oikealle.

size(X)
disp('Datapisteiden mr:');
disp(size(X,2));
disp('Datavektorin dimensio:');
disp(size(X,1));

%% Tulostetaan nytlle kaikki luvut

X

%% Piirretn 3D-kuva
% Piirtmisen jlkeen pyrittele akseleita
% (komento "rotate3d").

figure(21); clf;
plot3(X(1,:), X(2,:), X(3,:), 'x');
grid on;
title(['3D-data, N = 140']);
rotate3d

%% Joku mtt???
% Katsotaan keskiarvot, minimi- ja maksimiarvot sek histogrammi

mean(X')
min(X')
max(X')

figure(22); clf;
hist(X');
title('Datan histogrammi komponenteittain');
xlabel('Arvo');
ylabel('Kuinka monta osumaa');
legend({'#1','#2','#3'});

%% Datan esiksittely
% Oikeissa sovelluksissa datan esiksittely on aikaavievin
% osa projektia. Se vaikuttaa erittin merkittvsti siihen,
% millaisia lopullisia tuloksia saadaan.
%
% On siis havaittu, ett yhden nytteen yksi arvo on 
% poikkeuksellisen suuri - kyse voi olla vrst mittauksesta,
% virheest datan tallennuksessa / haussa tms. 
%
% Tehdn nyt yksinkertainen esiksittely eli poistetaan
% "viallinen" arvo (ns. "outlier"). Muita tapoja: korvataan
% keskiarvolla, korvataan regressiofunktion antamalla arvolla, ...

ind = find(X(2,:) > -100);
X   = X(:,ind);
size(X)

%% Piirretn uudestaan
% Pyrittele uudestaan

figure(21); clf;
plot3(X(1,:), X(2,:), X(3,:), 'x');
grid on;
title(['3D-data esiksiteltyn, N = 139']);
rotate3d

%% Tehtvt
%
% * Pyrittele akseleita - net nyt 2D-projektion tasollasi
% mutta kun pyrittelet, voit saada aistimuksen 3D:st.
%   * kuinka monta rypst mielestsi on?
%   * saatko pyritetty niin, ett on 2 rypst
%   * saatko pyritetty niin, ett on vain 1 ryps
% * Jt siihen asentoon, ett ryppt ovat parhaimmillaan erilln.

%% Lasketaan PCA
% Paperilaskarikierroksen #2 tehtvss 1 lasketaan PCA.
% Ensin vhennetn keskiarvo, sitten datamatriisista lasketaan
% sen kovarianssimatriisi ja tst edelleen ominaisarvot ja
% -vektorit.

N  = size(X,2);
ka = mean(X,2);
XK = X - repmat(ka, 1, N);
C  = (1/N)*XK*XK';  
[V,D] = eig(C);
kokon = sum(D(:));

%% Varmistetaan suurimman ominaisarvon omaava vektori ensimmiseksi
[dummy,jarj] = sort(diag(D));
jarj = flipud(jarj);
V = V(:,jarj);
D = D(:,jarj);

%% Lasketaan prosentit
pross = diag(D)/kokon;
saily = 100*(pross(1)+pross(2));
disp(['Silytetn ' num2str(saily) ' % vaihtelusta']);

%% Projisoidaan 2D-tasoon

Y = V(:,1:2)' * X;

figure(23); clf;
plot(Y(1,:), Y(2,:), 'x');
grid on;
axis equal;
title(['2D-projektio 3D-datasta, silytetty ' num2str(saily) '%']);

P = V(:,1:2) * Y + repmat(ka, 1, N);;
figure(21); hold on;
plot3(P(1,:),P(2,:),P(3,:),'ro');
title(['3D-data esiksiteltyn + projektio 2D:en, N = 139']);
rotate3d

