%% T-61.2010 Datasta tietoon / T#2 / 3
% Jukka Parviainen, 14.11.2006

clc;
clear;
close all;

%% Ominaiskasvot
% Luentojen luku 4, PCA: eigenfaces
%
% Datana kasvokuvia, jotka luetaan matriisiksi X,
% jossa sarakkeeksi tulee yksi kuva "skannattuna".
% Esim. 10 kuvasta, joiden koko 50x50 pikseli,
% tulisi 2500 rivi ja 10 saraketta.

%% Kuvakokoelma
% Kytetn MIT:n CBCL-kuvatietokantaa. Kts.
% |http://cbcl.mit.edu/cbcl/software-datasets/FaceData2.html|
%
% Kukin kasvokuva on 19 x 19 pikseli, tst tulee
% datavektorin dimensioksi 361. 
%
% HUOM! Voit valita mys jonkun muun tiedoston hakemistosta
% |http://www.cis.hut.fi/Opinnot/T-61.2010/Harjoitustyo/|
% kohdasta "Aihe #1". Tllin joudut kuitenkin tekemn
% datan muutokset itse seuraavassa kohdassa.

load dt_t2_m3_K.mat
% sislt muuttujan K

%% Piirretn kasvokuvat
% Kytetn apufunktiota myMontage.m ja
% piirretn kuvat ikkunaan 31.

myMontage(K, 'Kasvokuvat', 31);

%% Muutetaan datamatriisiksi
% Tss muokataan kuvamatriisin alkiot
% oikeaksi datamatriisiksi X ja pakotetaan
% tyyppi double-tyyppiseksi. Esim. help 
% reshape, help double.
%
% Aikaa ja vaivaa sstksemme, lataa
% valmiiksi skannattu matriisi X, jossa
% lisksi tehty esiksittelyn jokaisesta
% kuvasta sen harmaasvyn keskiarvo pois.
% Yritetn tasoittaa kuvausolosuhteita.
%
% HUOM! Eli jos latasin jonkun oman tiedoston,
% niin muuta kuvamuoto matriisiksi X.

load dt_t2_m3_X.mat
% sislt muuttujan X  (361 rivi==pikseli, N saraketta==kuvaa)

%% Varmistetaan K:n ja X:n koko
% K on kuvamatriisi dimensioissa (r x c x 1 x n)
% ja X datamatriisi (rc x n)
%
% Siten seuraavien alkioiden mrien pit olla samat.

disp(['K:n alkioiden lkm: ' num2str(prod(size(K))) ', X:n lkm ' num2str(prod(size(X)))]);

%% Tehdn PCA datalle
% Poistetaan keskiarvo, lasketaan kovarianssimatriisi, sen
% ominaisarvot ja -vektorit.

% KOODAA THN! (Kts. esim. demo 2)


%% Projisoidaan 2D:en
% Projisoidaan kasvokuvat 2D:en (matriisi Y).

Y = []; % laske projektio tmn paikalle!!!

figure(32); clf;
for k=[1:size(Y,2)]
    plot(Y(1,k), Y(2,k), 'bx');
    hold on;
    ti = text(Y(1,k),Y(2,k),[num2str(k)]);
    set(ti,'Color',[0 0 1]);
end;
grid on;
title(['Kasvokuvien projektio 2D:en']);

%% Ladataan testiaineisto: kasvoja ja "ei-kasvoja"
% Ladataan kaksi uutta testijoukkoa, jossa sek kasvoja ett
% ei-kasvoja. Projisoidaan kytten samaa projektiomatriisia.

load dt_t2_m3_K2.mat
myMontage(K2, 'Testijoukko KASVOT', 33);
load dt_t2_m3_K3.mat
myMontage(K3, 'Testijoukko EI-KASVOT', 34);

% Edelleen seuraavassa valmiiksi esiksitelly datamatriisit:
load dt_t2_m3_X2.mat
% sislt muuttujan X2  (361 rivi==pikseli, N saraketta==kuvaa)
load dt_t2_m3_X3.mat
% sislt muuttujan X3  (361 rivi==pikseli, N saraketta==kuvaa)

%% Projektio kytten valmista projektiomatriisia
% Laske tss X2:n ja X3:n projektiot Y2 ja Y3 kytten (alkuperisest
% datasta laskettua) kahden
% "suurimman" ominaisvektorin muodostamaa matriisia

Y2 = []; % laske projektio tmn paikalle!!!
Y3 = []; % laske projektio tmn paikalle!!!

figure(32);
hold on;
for k=[1:size(Y2,2)]
    plot(Y2(1,k), Y2(2,k), 'ro');
    ti = text(Y2(1,k)-3,Y2(2,k),[num2str(k)]);
    set(ti,'Color',[1 0 0]);
end;
for k=[1:size(Y3,2)]
    plot(Y3(1,k), Y3(2,k), 'kd');
    ti = text(Y3(1,k),Y3(2,k)+3,[num2str(k)]);
    set(ti,'Color',[0 0 0]);
end;
title('Projektiot: x kasvokuvat opetus, o kasvokuvat testi, <> ei-kasvot');
